ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.4 by root, Tue Dec 7 09:27:54 2010 UTC vs.
Revision 1.33 by root, Thu Feb 24 07:10:03 2011 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
42 42
43# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
44# required by mkbundle 44# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 46
47# which extra modules you might want to install 47# which extra modules you might want to install
48EXTRA_MODULES="" 48EXTRA_MODULES=""
49 49
50# overridable functions 50# overridable functions
51preconfigure() { : ; }
51postconfigure() { : ; } 52postconfigure() { : ; }
52postbuild() { : ; } 53postbuild() { : ; }
53postinstall() { : ; } 54postinstall() { : ; }
54 55
55# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
59 64
60############################################################################# 65#############################################################################
61# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
62 73
63# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
65$VERSION=0.1 76$VERSION="1.1"
66 77
67BZ2=bz2 78BZ2=bz2
68BZIP2=bzip2 79BZIP2=bzip2
69 80
70fatal() { 81fatal() {
103############################################################################# 114#############################################################################
104# clean 115# clean
105 116
106distclean() { 117distclean() {
107 verblock <<EOF 118 verblock <<EOF
108deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 120EOF
110 121
111 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
112} 123}
113 124
114############################################################################# 125#############################################################################
115# download/configure/compile/install perl 126# download/configure/compile/install perl
116 127
117clean() { 128clean() {
118 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
119 131
120 rm -f staticstamp.configure 132realclean() {
121 make distclean >/dev/null 2>&1 133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
122} 136}
123 137
124fetch() { 138fetch() {
125 rcd "$STATICPERL" 139 rcd "$STATICPERL"
126 140
127 mkdir -p src 141 mkdir -p src
128 rcd src 142 rcd src
129 143
130 if ! [ -d "perl-$PERLVER" ]; then 144 if ! [ -d "perl-$PERL_VERSION" ]; then
131 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 145 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
132 146
133 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 147 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
134 148
135 verblock <<EOF 149 verblock <<EOF
136downloading perl 150downloading perl
137to manually download perl yourself, place 151to manually download perl yourself, place
138perl-$PERLVER.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
139trying $URL 153trying $URL
140EOF 154EOF
141 155
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
142 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || fatal "$URL: error during downloading" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
145 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
146 fi 162 fi
147 163
148 verblock <<EOF 164 verblock <<EOF
149unpacking perl 165unpacking perl
150EOF 166EOF
151 167
152 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
153 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \
154 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERLVER perl-$PERLVER 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 174 rmdir -p unpack
157 fi 175 fi
158} 176}
159 177
160# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
161sedreplace() { 179sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
163 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
164} 209}
165 210
166configure() { 211configure() {
167 fetch 212 fetch
168 213
169 rcd "$STATICPERL/src/perl-$PERLVER" 214 rcd "$STATICPERL/src/perl-$PERL_VERSION"
170 215
171 [ -e staticstamp.configure ] && return 216 [ -e staticstamp.configure ] && return
172 217
173 verblock <<EOF 218 verblock <<EOF
174configuring $STATICPERL/src/perl-$PERLVER 219configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 220EOF
176 221
177 clean
178
179 rm -f "$PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
180 223
224 "$MAKE" distclean >/dev/null 2>&1
225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
181 # I hate them 228 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231
232 preconfigure
184 233
185# trace configure \ 234# trace configure \
186 sh Configure -Duselargefiles \ 235 sh Configure -Duselargefiles \
187 -Uuse64bitint \ 236 -Uuse64bitint \
188 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
189 -Uusedl \ 238 -Uusedl \
190 -Uusethreads \ 239 -Uusethreads \
191 -Uuseithreads \ 240 -Uuseithreads \
192 -Uusemultiplicity \ 241 -Uusemultiplicity \
193 -Duseperlio \
194 -Uusesfio \ 242 -Uusesfio \
195 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
196 -Dcppflags="$PERL_CPPFLAGS" \ 245 -A ccflags=" $PERL_CCFLAGS" \
197 -Dccflags="-g2 -fno-strict-aliasing" \ 246 -Dcc="$PERL_CC" \
198 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
199 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
200 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
201 -Dprefix="$PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
202 -Dbin="$PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
203 -Dprivlib="$PREFIX/lib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
204 -Darchlib="$PREFIX/lib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
205 -Uusevendorprefix \ 254 -Uusevendorprefix \
206 -Dsitelib="$PREFIX/lib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
207 -Dsitearch="$PREFIX/lib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
208 -Usitelibexp \
209 -Uman1dir \ 257 -Uman1dir \
210 -Uman3dir \ 258 -Uman3dir \
211 -Usiteman1dir \ 259 -Usiteman1dir \
212 -Usiteman3dir \ 260 -Usiteman3dir \
213 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
214 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
215 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
216 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
217 $PERL_CONFIGURE \ 265 $PERL_CONFIGURE \
266 -Duseperlio \
218 -dE || fatal "Configure failed" 267 -dE || configure_failure
219 268
220 sedreplace ' 269 sedreplace '
221 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
222 s/ *-fno-stack-protector */ /g 271 s/ *-fno-stack-protector */ /g
223 ' config.sh 272 ' config.sh
230} 279}
231 280
232build() { 281build() {
233 configure 282 configure
234 283
235 rcd "$STATICPERL/src/perl-$PERLVER" 284 rcd "$STATICPERL/src/perl-$PERL_VERSION"
236 285
237 verblock <<EOF 286 verblock <<EOF
238building $STATICPERL/src/perl-$PERLVER 287building $STATICPERL/src/perl-$PERL_VERSION
239EOF 288EOF
240 289
241 rm -f "$PREFIX/staticstamp.install" 290 rm -f "$PERL_PREFIX/staticstamp.install"
242 291
243 make || fatal "make: error while building perl" 292 "$MAKE" || fatal "make: error while building perl"
244 293
245 postbuild || fatal "postbuild hook failed" 294 postbuild || fatal "postbuild hook failed"
246} 295}
247 296
248install() { 297install() {
249 [ -e "$PREFIX/staticstamp.install" ] && return 298 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
250
251 build 299 build
252 300
253 verblock <<EOF 301 verblock <<EOF
254installing $STATICPERL/src/perl-$PERLVER 302installing $STATICPERL/src/perl-$PERL_VERSION
255to $PREFIX 303to $PERL_PREFIX
256EOF 304EOF
257 305
258 rm -rf "$PREFIX" 306 ln -sf "perl/bin/" "$STATICPERL/bin"
259 307 ln -sf "perl/lib/" "$STATICPERL/lib"
308
309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
310 rm -rf "$PERL_PREFIX" # by this rm -rf
311
260 make install || fatal "make install: error while installing" 312 "$MAKE" install || fatal "make install: error while installing"
261 313
262 rcd "$PREFIX" 314 rcd "$PERL_PREFIX"
263 315
264 # create a "make install" replacement for CPAN 316 # create a "make install" replacement for CPAN
265 cat >"$PREFIX"/bin/cpan-make-install <<EOF 317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
266make install UNINST=1 318"$MAKE" || exit
319
267if find blib/arch/auto -type f | grep -q -v .exists; then 320if find blib/arch/auto -type f | grep -q -v .exists; then
268 echo Probably an XS module, rebuilding perl 321 echo Probably an XS module, rebuilding perl
269 make perl 322 if "$MAKE" perl; then
323 mv perl "$PERL_PREFIX"/bin/perl~ \
270 rm -f "$PREFIX"/bin/perl 324 && rm -f "$PERL_PREFIX"/bin/perl \
271 make -f Makefile.aperl inst_perl 325 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
272 make -f Makefile.aperl map_clean 326 "$MAKE" -f Makefile.aperl map_clean
327 else
328 "$MAKE" -f Makefile.aperl map_clean
329 exit 1
330 fi
273fi 331fi
332
333"$MAKE" install UNINST=1
274EOF 334EOF
275 chmod 755 "$PREFIX"/bin/cpan-make-install 335 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
276 336
277 # trick CPAN into avoiding ~/.cpan completely 337 # trick CPAN into avoiding ~/.cpan completely
278 echo 1 >"$PREFIX/lib/CPAN/MyConfig.pm" 338 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
279 339
280 "$PREFIX"/bin/perl -MCPAN -e ' 340 "$PERL_PREFIX"/bin/perl -MCPAN -e '
281 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 341 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
282 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
283 CPAN::Shell->o (conf => q<init>); 343 CPAN::Shell->o (conf => q<init>);
284 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 344 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
285 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 345 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
286 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 346 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
287 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 347 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
288 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 348 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
289 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 349 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
290 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 350 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
291 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 351 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
292 CPAN::Shell->o (conf => q<commit>); 352 CPAN::Shell->o (conf => q<commit>);
293 ' || fatal "error while initialising CPAN" 353 ' || fatal "error while initialising CPAN"
294 354
355 touch "$PERL_PREFIX/staticstamp.install"
356 fi
357
358 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
295 NOCHECK_INSTALL=+ 359 NOCHECK_INSTALL=+
296 instcpan $STATICPERL_MODULES 360 instcpan $STATICPERL_MODULES
297 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 361 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
298 362
299 postinstall || fatal "postinstall hook failed" 363 postinstall || fatal "postinstall hook failed"
300 364
301 touch "$PREFIX/staticstamp.install" 365 touch "$PERL_PREFIX/staticstamp.postinstall"
366 fi
302} 367}
303 368
304############################################################################# 369#############################################################################
305# install a module from CPAN 370# install a module from CPAN
306 371
311installing modules from CPAN 376installing modules from CPAN
312$@ 377$@
313EOF 378EOF
314 379
315 for mod in "$@"; do 380 for mod in "$@"; do
316 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 381 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
317 || fatal "$mod: unable to install from CPAN" 382 || fatal "$mod: unable to install from CPAN"
318 done 383 done
319 rm -rf "$STATICPERL/build" 384 rm -rf "$STATICPERL/build"
320} 385}
321 386
333 for mod in "$@"; do 398 for mod in "$@"; do
334 echo 399 echo
335 echo $mod 400 echo $mod
336 ( 401 (
337 rcd $mod 402 rcd $mod
338 make -f Makefile.aperl map_clean >/dev/null 2>&1 403 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
339 make distclean >/dev/null 2>&1 404 "$MAKE" distclean >/dev/null 2>&1
340 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 405 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
341 make || fatal "$mod: error building module" 406 "$MAKE" || fatal "$mod: error building module"
342 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 407 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
343 make distclean >/dev/null 2>&1 408 "$MAKE" distclean >/dev/null 2>&1
344 exit 0 409 exit 0
345 ) || exit $? 410 ) || exit $?
346 done 411 done
347} 412}
348 413
349############################################################################# 414#############################################################################
350# do schmorpy stuff
351
352MODSRCDIR=~/src
353
354instmodsrc() {
355 for mod in "$@"; do
356 instmod_src "$MODSRCDIR/$mod"
357 done
358}
359
360install_schmorp() {
361 install
362
363 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
364 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
365 #instcpan Net::SSLeay # requires static -ldl
366
367 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
368 instmodsrc EV Guard Async-Interrupt IO-AIO
369 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
370 instmodsrc Linux-Inotify2 EV-Loop-Async
371
372 instcpan AnyEvent::HTTPD
373}
374
375#############################################################################
376# main 415# main
377 416
378podusage() { 417podusage() {
379 echo 418 echo
419
380 if [ -e "$PREFIX/bin/perl" ]; then 420 if [ -e "$PERL_PREFIX/bin/perl" ]; then
381 "$PREFIX/bin/perl" -MPod::Usage -e \ 421 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
382 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 422 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
383 2>/dev/null && exit 423 2>/dev/null && exit
384 fi 424 fi
425
385 # try whatever perl we can find 426 # try whatever perl we can find
386 perl -MPod::Usage -e \ 427 perl -MPod::Usage -e \
387 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 428 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
388 2>/dev/null && exit 429 2>/dev/null && exit
389 430
390 fatal "displaying documentation requires a working perl - try '$0 install' first" 431 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
391} 432}
392 433
393usage() { 434usage() {
394 podusage 0 435 podusage 0
395} 436}
396 437
397catmkbundle() { 438catmkbundle() {
398 { 439 {
399 read dummy 440 read dummy
400 echo "#!$PREFIX/bin/perl" 441 echo "#!$PERL_PREFIX/bin/perl"
401 cat 442 cat
402 } <<'MKBUNDLE' 443 } <<'MKBUNDLE'
403#CAT mkbundle 444#CAT mkbundle
404MKBUNDLE 445MKBUNDLE
405} 446}
406 447
407bundle() { 448bundle() {
408 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 449 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
409 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 450 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
451 CACHE="$STATICPERL/cache"
452 mkdir -p "$CACHE"
410 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 453 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
411} 454}
412 455
413if [ $# -gt 0 ]; then 456if [ $# -gt 0 ]; then
414 while [ $# -gt 0 ]; do 457 while [ $# -gt 0 ]; do
415 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 458 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
416 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 459 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
417 460
418 command="${1#--}"; shift 461 command="${1#--}"; shift
419 case "$command" in 462 case "$command" in
463 version )
464 echo "staticperl version $VERSION"
465 ;;
420 fetch | configure | build | install | clean | distclean) 466 fetch | configure | build | install | clean | realclean | distclean)
421 verblock <<EOF
422$command
423EOF
424 "$command" 467 ( "$command" ) || exit
425 ;; 468 ;;
426 instsrc ) 469 instsrc )
427 instsrc "$@" 470 ( instsrc "$@" ) || exit
428 exit 471 exit
429 ;; 472 ;;
430 instcpan ) 473 instcpan )
431 instcpan "$@" 474 ( instcpan "$@" ) || exit
432 exit 475 exit
433 ;; 476 ;;
434 instschmorp )
435 install_schmorp
436 ;;
437 cpan ) 477 cpan )
438 install 478 ( install ) || exit
439 "$PREFIX/bin/cpan" "$@" 479 "$PERL_PREFIX/bin/cpan" "$@"
440 exit 480 exit
441 ;; 481 ;;
442 mkbundle ) 482 mkbundle )
443 install 483 ( install ) || exit
444 bundle "$@" 484 bundle "$@"
445 exit 485 exit
446 ;; 486 ;;
447 mkperl ) 487 mkperl )
448 install 488 ( install ) || exit
449 bundle --perl "$@" 489 bundle --perl "$@"
490 exit
491 ;;
492 mkapp )
493 ( install ) || exit
494 bundle --app "$@"
450 exit 495 exit
451 ;; 496 ;;
452 help ) 497 help )
453 podusage 2 498 podusage 2
454 ;; 499 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines